/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.sendaAmigo;

import com.rjconsultores.ventaboletos.entidad.ParamAcumulaPunto;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.service.ParamAcumulaPuntoService;
import com.rjconsultores.ventaboletos.service.ParadaService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderSendaAmigoParamAcumulaPunto;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Datebox;
import org.zkoss.zul.Paging;

/**
 *
 * @author Rafius //ParamAcumulaPunto
 */
@Controller("busquedaAcumulacionPorVentaController")
@Scope("prototype")
public class BusquedaAcumulacionPorVentaController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<ParamAcumulaPunto> plwParamAcumulaPunto;
    @Autowired
    private ParamAcumulaPuntoService paramAcumulaPuntoService;
    @Autowired
    private ParadaService paradaService;
    private List<ParamAcumulaPunto> lsParamAcumulaPunto;
    private Combobox cmbOrigem;
    private Combobox cmbDestino;
    private Datebox fecInicio;
    private Datebox fecFinal;
    private MyListbox paramAcumulaPuntoList;
    private Paging pagingParamAcumulaPunto;

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        paramAcumulaPuntoList.setItemRenderer(new RenderSendaAmigoParamAcumulaPunto());
        paramAcumulaPuntoList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                ParamAcumulaPunto pa = (ParamAcumulaPunto) paramAcumulaPuntoList.getSelected();
                verParamAcumulaPunto(pa);
            }
        });

        lsParamAcumulaPunto = new ArrayList<ParamAcumulaPunto>();

        refreshLista();
    }

    public void onClick$btnPesquisa(Event ev) throws InterruptedException {

        Parada origem = (Parada) (cmbOrigem.getSelectedItem() != null ? cmbOrigem.getSelectedItem().getValue() : null);
        Parada destino = (Parada) (cmbDestino.getSelectedItem() != null ? cmbDestino.getSelectedItem().getValue() : null);

        lsParamAcumulaPunto.clear();
        lsParamAcumulaPunto.addAll(paramAcumulaPuntoService.buscar(origem, destino, fecInicio.getValue(), fecFinal.getValue()));
        paramAcumulaPuntoList.setData(lsParamAcumulaPunto);

        if (paramAcumulaPuntoList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("editarParamAcumulaPuntoController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verParamAcumulaPunto(new ParamAcumulaPunto());
    }

    private void verParamAcumulaPunto(ParamAcumulaPunto pa) {
        if (pa == null) {
            return;
        }

        Map args = new HashMap();
        args.put("paramAcumulaPunto", pa);
        args.put("paramAcumulaPuntoList", paramAcumulaPuntoList);

        openWindow("/gui/senda_amigo/editarParamAcumulaPunto.zul",
                Labels.getLabel("editarParamAcumulaPuntoController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<ParamAcumulaPunto> tarifaBusqueda =
                new HibernateSearchObject<ParamAcumulaPunto>(ParamAcumulaPunto.class, pagingParamAcumulaPunto.getPageSize());
        tarifaBusqueda.addFilterEqual("activo", Boolean.TRUE);
        tarifaBusqueda.addSortAsc("feciniciovigencia");
        plwParamAcumulaPunto.init(tarifaBusqueda, paramAcumulaPuntoList, pagingParamAcumulaPunto);
    }

    public Paging getPagingParamAcumulaPunto() {
        return pagingParamAcumulaPunto;
    }

    public void setPagingParamAcumulaPunto(Paging pagingParamAcumulaPunto) {
        this.pagingParamAcumulaPunto = pagingParamAcumulaPunto;
    }

    public Combobox getCmbDestino() {
        return cmbDestino;
    }

    public void setCmbDestino(Combobox cmbDestino) {
        this.cmbDestino = cmbDestino;
    }

    public Combobox getCmbOrigem() {
        return cmbOrigem;
    }

    public void setCmbOrigem(Combobox cmbOrigem) {
        this.cmbOrigem = cmbOrigem;
    }
}
